/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.tracker;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleEvent;
import org.osgi.util.tracker.BundleTracker;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api.Adapter;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.impl.DefaultAdapter;

import java.util.Optional;

public class AdapterTracker extends BundleTracker {
	
	protected static final Logger log = LoggerFactory.getLogger(AdapterTracker.class);
	
	protected AdapterHelper helper;
	
	@SuppressWarnings("unchecked")
	public AdapterTracker(BundleContext bundleContext) {
		super(bundleContext, Bundle.ACTIVE, null);
		this.helper = new AdapterHelper(bundleContext);
	}
	
	@Override
	public Object addingBundle(Bundle bundle, BundleEvent event) {
		String isAdapter = bundle.getHeaders().get(Adapter.ADAPTER_HEADER_NAME);
		if (Boolean.valueOf(isAdapter)) {
			String className = Optional.ofNullable(bundle.getHeaders().
					get(Adapter.ADAPTER_CLASS_HEADER_NAME)).orElse(DefaultAdapter.class.getName());
			log.debug("Adapter class " + className + " FOUND IN BUNDLE " + bundle.getSymbolicName());
			helper.create(bundle, className);
		}
		return bundle;
	}
}
